/*
 * CPlugin Class
 * by hackervalley@free.fr
 * http://hackervalley.free.fr
 * April 2004
 * this program is licensed under the GPL.
 */

#include "Plugin.hh"

#include <iostream>

using namespace std;

CPlugin::CPlugin ()
{
}

void
CPlugin::vOpen (const string filename, int flag)
{

	handle = dlopen (filename.c_str (), flag);

	cout << "Filename :" << filename << endl;
	cout << "Flag :" << flag << endl;
	cout << "Handle :" << handle << endl;
	
	if (!handle)
	{
		error = dlerror ();
		cout << error << endl;
		exit(1);
	}
	else
		cout << filename << " open " << endl;
}

void
CPlugin::vClose ()
{
	if (dlclose (handle) != 0)
	{
		error = dlerror ();
		cout << string(error) << endl;
		cout << filename << " NOT CLOSED " << endl;
	}
	else
		cout << "Shared Object closed " << endl;
}

void *
CPlugin::vSymbol(const char * symbol)
{
	dlerror();    /* Clear any existing error */
	sym = dlsym(handle, symbol);
	if (!sym)
	{error = dlerror();
	if (error != 0)
		cout << error << endl;
		exit(1);
	}
	else
	cout << symbol << " " << sym << endl;
	
	return sym;
}
