/*
 * Plugin Class
 * by hackervalley@free.fr
 * http://hackervalley.free.fr
 * April 2004
 * this program is licensed under the GPL.
 */
 
 /*
 Dynamic loader
 See man dlopen
 */
 
 #ifndef PLUGIN_HH
#define PLUGIN_HH

extern "C"
{
// Header for dynamically load libraries
#include <dlfcn.h>
}

#include <string>

using namespace std;

class CPlugin
{
	public :
		
	CPlugin();
	
	// See <dlfcn.h> for definition of flag
	void vOpen(const string filename, int flag=RTLD_NOW);
	void vClose();
	void * vSymbol(const char *symbol);
	
	private:
		const string filename; 
		int flag;
		void *handle;
		char *error;
		const char *symbol;
	    void *sym;
};

#endif // PLUGIN_HH
